目录

Updating the Entire Event Ticket Instance

Function

Overwrites an event ticket instance based on instanceId.

Scenario

This API is used to update the entire event ticket instance based on instanceId. All parameters except passTypeIdentifier, organizationPassId, and serialNumber (namely, instanceId) can be updated. The value of passStyleIdentifier (namely, modelId) can be changed to another event ticket model ID with the same passTypeIdentifier.

Restrictions

You need to create an app in AppGallery Connect and apply for services corresponding to the passes. In addition, only an instance that has been added to the Huawei server can be updated.

Prototype

Protocol

HTTPS PUT

Direction

Developer server -> Huawei server

URL

{url}/hmspass/v1/eventticket/instance/{instanceId}

Set the {url} variable based on the region where the server is located. For details, please refer to Wallet Server Addresses.

Data Format

Request: Content-Type: application/json

Response: Content-Type: application/json

URL Parameters

Parameter

Mandatory/Optional

Type

Description

instanceId

Mandatory

String

Unique identifier of an instance. It must be unique across all instances sharing the same appId. The value contains only letters, digits, dots (.), hyphens (-), and underscores (_).

Request Parameters

Request Header

Parameter

Mandatory/Optional

Type

Description

Authorization

Mandatory

String

Authorization code. For details about how to obtain the value, please refer to the Client Credentials mode in OAuth 2.0-based Authentication. In this mode, client_id and client_secret are respectively the App ID and App key of the app that you created in AppGallery Connect. Concatenate the value of access_token to the end of Bearer, with a space in between, to generate the value of Authorization.

Content-Type

Mandatory

String

The value is always application/json;charset=utf-8.

Accept

Mandatory

String

The value is always application/json;charset=utf-8.

Request Body

Parameter

Mandatory/Optional

Type

Description

For details, please refer to the HwWalletObject Parameters.

Mandatory

HwWalletObject

Pass instance to be updated.

Request Example

PUT /hmspass/v1/eventticket/instance/10001 HTTP/1.1
Content-Type: application/json;charset=utf-8
Authorization: Bearer ***
Accept: application/json;charset=utf-8
Host: wallet-passentrust-drcn.cloud.huawei.com.cn
{
  "organizationPassId": "5623489234",
  "passTypeIdentifier": "hwpass.com.huawei.wallet.eventticket.test",
  "passStyleIdentifier": "eventTicketModelTest",
  "serialNumber": "10001",
  "fields": {
    "status": {
      "state": "active",
      "effectTime": "2019-11-13T00:00:00.111Z",
      "expireTime": "2020-11-20T00:00:00.111Z"
    },
    "barCode": {
      "text": "562348969211212",
      "type": "codabar",
      "value": "562348969211212",
      "encoding": "UTF-8"
    },
    "commonFields": [
      {
        "key": "ticketNumber",
        "value": "12345678"
      }
    ],
    "appendFields": [
      {
        "key": "gate",
        "value": "Gate 2",
        "label": "Gate"
      },
      {
        "key": "section",
        "value": "Section 3",
        "label": "Section"
      },
      {
        "key": "row",
        "value": "Row 20",
        "label": "Row"
      },
      {
        "key": "seat",
        "value": "Seat 10",
        "label": "Seat"
      },
      {
        "key": "userName",
        "value": "Joe Wiley"
      }
    ]
  }
}

Response Parameters

When the result code is 200:

Parameter

Type

Description

For details, please refer to the HwWalletObject Parameters.

HwWalletObject

Updated pass instance.

Response Example

HTTP/1.1 200 OK
Content-Type: application/json
{
  "organizationPassId": "5623489234",
  "passTypeIdentifier": "hwpass.com.huawei.wallet.eventticket.test",
  "passStyleIdentifier": "eventTicketModelTest",
  "serialNumber": "10001",
  "fields": {
    "status": {
      "state": "active",
      "effectTime": "2019-11-13T00:00:00.111Z",
      "expireTime": "2020-11-20T00:00:00.111Z"
    },
    "barCode": {
      "text": "562348969211212",
      "type": "codabar",
      "value": "562348969211212",
      "encoding": "UTF-8"
    },
    "commonFields": [
      {
        "key": "ticketNumber",
        "value": "12345678"
      }
    ],
    "appendFields": [
      {
        "key": "gate",
        "value": "Gate 2",
        "label": "Gate"
      },
      {
        "key": "section",
        "value": "Section 3",
        "label": "Section"
      },
      {
        "key": "row",
        "value": "Row 20",
        "label": "Row"
      },
      {
        "key": "seat",
        "value": "Seat 10",
        "label": "Seat"
      },
      {
        "key": "userName",
        "value": "Joe Wiley"
      }
    ]
  }
}

Result Codes

For details, please refer to Result Codes.

Call Example

public HwWalletObject fullUpdateWalletInstance(String url, String instanceId, HwWalletObject body) {
    // Construct the HTTP header.
    HttpHeaders header = constructHttpHeaders();
    // Construct the HTTP URL.
    String baseUrl = ConfigHelper.instants().getValue("walletServerBaseUrl");
    String walletServerUrl = baseUrl + url + instanceId;
    // Construct the HTTP body.
    String hwLoyaltyInstance = CommonUtil.toJson(body);
    JSONObject jsonObj = JSONObject.parseObject(hwLoyaltyInstance);

    // Send the HTTP request and obtain the response.
    HttpEntity<JSONObject> entity = new HttpEntity<>(jsonObj, header);
    ResponseEntity<HwWalletObject> response =
        REST_TEMPLATE.exchange(walletServerUrl, HttpMethod.PUT, entity, HwWalletObject.class);

    // Return the updated wallet instance.
    return response.getBody();
}